#include "camera.h"

camera::camera(shiftRegister8 *shiftRegister, byte maskRelay1, byte maskRelay2)
{
    // set member variables
    this->shiftRegister = shiftRegister;
    this->maskRelay1 = maskRelay1;
    this->maskRelay2 = maskRelay2;
    this->reverseRelays = false;
    this->halfPressState = false;
    this->fullPressState = false;
}

camera::~camera() {}

// ----------------------------------------------------------------------------------------------------
// This function sets the half-press state
// ----------------------------------------------------------------------------------------------------

void camera::setHalfPress(boolean state)
{
    if (!this->reverseRelays)
    {
        this->shiftRegister->set(this->maskRelay1,state);
    }
    else
    {
        this->shiftRegister->set(this->maskRelay2,state);
    }
    this->halfPressState = state;
}

// ----------------------------------------------------------------------------------------------------
// This function sets the full-press state
// ----------------------------------------------------------------------------------------------------

void camera::setFullPress(boolean state)
{
    if (!this->reverseRelays)
    {
        this->shiftRegister->set(this->maskRelay2,state);
    }
    else
    {
        this->shiftRegister->set(this->maskRelay1,state);
    }
    this->fullPressState = state;
}
