/*
  camera.h - a simple library for controlling a camera's shutter via two reed relays or optoisolators attached to a shift register
  Written by Rylee Isitt
*/
#ifndef camera_H
#define camera_H

#include <Arduino.h>
#include "shiftRegister8.h"

class camera
{
public:
    camera(shiftRegister8 *shiftRegister, byte maskRelay1, byte maskRelay2);
    ~camera(void);
    void setHalfPress(boolean state);
    void setFullPress(boolean state);
    boolean halfPressState;
    boolean fullPressState;
    boolean reverseRelays;
private:
    shiftRegister8 * shiftRegister;
    byte maskRelay1;
    byte maskRelay2;
};

#endif
