/*
  shiftRegister8.h - library for interfacing with an 8 bit shift register
  Written by Rylee Isitt
  This library is distributed as freeware
*/
#ifndef shiftRegister8_H
#define shiftRegister8_H

#include <Arduino.h>

class shiftRegister8
{
public:
    shiftRegister8();
    ~shiftRegister8();
    void begin(byte dataPin, byte latchPin, byte clockPin);
    void set(byte bitMask, boolean setting, boolean queue = false);
    void update(void);
private:
    byte dataPin;
    byte latchPin;
    byte clockPin;
    byte registerState;
    boolean updateRegister;
};

#endif
